﻿Public Class Form1

    Enum tprgResult

        resNone = 0
        resOk = 1
        progDone = 2
        noProg = 3
        progFound = 4
        progBusy = 5
        progDefect = 6
        progIdle = 7
        progComErr = 8
        progTimeOutErr = 9
        PwrDownErr = 10
        PwrSupplyErr = 11
        SignatureErr = 12
        invPassword = 13
        limitExc = 14
        eraChip = 15
        eraFlash = 16
        eraEEp = 17
        eraUsrRow = 18
        ProtectedErr = 19
        NotEmptyErr = 20
        prgFlash = 21
        prgEEp = 22
        prgUsrRow = 23
        verifyFlash = 24
        verifyEEp = 25
        verifyUsrRow = 26
        VerifyErr = 27
        dwnLoading = 28
        ParmErr = 29
        dwnLoadErrF = 30
        dwnLoadErrE = 31
        dwnLoadErrU = 32
        invFile = 33
        invFName = 34
        FileExist = 35
        FileNotFound = 36
        FileErr = 37
        FileDwnErr = 38
        MMCok = 39
        MMCprotected = 40
        MMCnoMedia = 41
        MMCmissing = 42
        MMCinitFailed = 43
        MMCresetFailed = 44
        MMCcheckFailed = 45
        MMCnoProg = 46
        MMCprogBusy = 47
        dummy = Int32.MaxValue
    End Enum

    Enum chState
        cIdle = 0
        cProg = 1
        cErase = 2
        cVerify = 3
    End Enum

    ' Dim prgResult As tprgResult
    ' prgResult = tprgResult.resOK Or filePermissions.read


    Public Declare Sub AbortAll Lib "UPP1X_DLL.dll" ()
    Public Declare Sub GetProgIDs Lib "UPP1X_DLL.dll" (ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub InitChannel Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub GetFileNames Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)

    Public Declare Sub OpenAfile Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal FileName As String, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub DeleteAfile Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal FileName As String, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub DownloadFile Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal FileName As String, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub GetProjParams Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal FileName As String, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub CloseAfile Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub GetTargVolt Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef Volt As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub EraseDevice Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub GetProgStatus Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub ProgDevice Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub ReleaseTarget Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub VerifyDevice Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub GetFuses Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal selfuse As Char, ByRef fuse As Integer, ByRef result As tprgResult, ByVal resString As String)

    Public Declare Sub DownOverBlockF Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal PData As IntPtr, ByVal ByValAdr As Integer, ByVal Count As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub DownOverBlockE Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal PData As IntPtr, ByVal ByValAdr As Integer, ByVal Count As Integer, ByRef result As tprgResult, ByVal resString As String)
    Public Declare Sub DownOverBlockU Lib "UPP1X_DLL.dll" (ByVal channel As Integer, ByVal PData As IntPtr, ByVal ByValAdr As Integer, ByVal Count As Integer, ByRef result As tprgResult, ByVal resString As String)

    '........


    Private Declare Function GetTickCount Lib "kernel32" () As Long

    Private FileisOpen As Boolean = False
    Private ProgrammersFound As Integer = 0
    Private cStatus As chState = chState.cIdle
    Private SelectedFile As String = ""
    Dim strLast As String = ""
    Dim str As String = ""
    Dim lIndex As Integer = 0
    Dim StartTime As Long
    Dim EndTime As Long
  

    '*******************************************************************************
    Private Sub DisableButtons(ByVal grp As GroupBox)
        For Each c As Control In grp.Controls
            If c.Name <> "btnAbortAll" Then
                c.Enabled = False
            End If
        Next
    End Sub

    Private Sub EnableButtons(ByVal grp As GroupBox)
        For Each c As Control In grp.Controls
            If c.Name <> "btnAbortAll" Then
                c.Enabled = True
            End If
        Next
    End Sub
    '*******************************************************************************

    Private Sub Form1_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        DisableButtons(GroupBox1)
        DisableButtons(GroupBox2)
        DisableButtons(GroupBox3)
        DisableButtons(GroupBox4)
    End Sub
    '*******************************************************************************
    Private Sub btnAbortAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbortAll.Click
        Cursor.Current = Cursors.WaitCursor
        Try
            cStatus = chState.cIdle
            Memo.Clear()
            comboBoxFiles.IntegralHeight = False
            comboBoxFiles.Items.Clear()
            comboBoxFiles.Text = ""
            FileisOpen = False
            statusBar.Items(0).Text = ""
            TimerProgStatus.Enabled = False
            DisableButtons(GroupBox1)
            DisableButtons(GroupBox2)
            DisableButtons(GroupBox3)
            DisableButtons(GroupBox4)
            GroupBox2.Enabled = False
            btnOpenAFile.Text = "OpenAfile"
            Memo.AppendText("AbortAll():")
            Application.DoEvents()
            AbortAll()
            btnGetProgIDs.Enabled = True
        Finally
            Cursor.Current = Cursors.Default
        End Try
    End Sub
    '*******************************************************************************
    Private Sub btnGetProgIDs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetProgIDs.Click

        Dim res As tprgResult = tprgResult.resOk
        Dim cnt As Integer = 0
        Dim isDemo As Boolean = False
        Dim strRes As String = ""
        Dim strProg As String
        Dim str1 As String = " "
        statusBar.Items(0).Text = ""
        ProgrammersFound = 0

        strProg = Space(500)
        GetProgIDs(res, strProg)
        strRes = strProg.ToString()
        Dim Serials() As String
        Serials = strRes.Split(ControlChars.CrLf.ToCharArray(), StringSplitOptions.RemoveEmptyEntries)

        For cnt = LBound(Serials) To (UBound(Serials) - 1)
            If Serials(cnt).Length > 15 Then
                isDemo = True
            Else
                ProgrammersFound = ProgrammersFound + 1
            End If
            Memo.AppendText("GetProgIDs: " + Serials(cnt) & vbCrLf)
        Next cnt

        Memo.AppendText("GetProgIDs: Devices found " + ProgrammersFound.ToString)
        Memo.AppendText(vbCrLf)
        If ProgrammersFound > 0 Then
            btnInitChannel.Enabled = True
        End If
    End Sub

    Private Sub btnInitChannel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInitChannel.Click
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        statusBar.Items(0).Text = ""
        strProg = Space(500)
        InitChannel(0, res, strProg)
        strRes = strProg.ToString()

        Memo.AppendText(("Initchannel Channel: 0" + "-> Result: " + res.ToString + ", Message: ") + strRes)
        Memo.AppendText(vbCrLf)
        If res = tprgResult.progFound Then
            EnableButtons(GroupBox4)
            GroupBox2.Enabled = True
            GroupBox3.Enabled = True
            GroupBox4.Enabled = True
            btnGetFiles.Enabled = True
            btnDownloadFile.Enabled = True
            btnTargetVoltage.Enabled = True
        End If
    End Sub

    Private Sub btnGetFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetFiles.Click
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        Dim value() As String
        Dim cnt As Integer = 0
        statusBar.Items(0).Text = ""
        comboBoxFiles.Enabled = True
        btnDeleteFile.Enabled = False
        btnGetProjParams.Enabled = False
        comboBoxFiles.Items.Clear()
        comboBoxFiles.Text = ""
        strProg = Space(500)
        GetFileNames(0, res, strProg)
        strRes = strProg.ToString()
        value = strRes.Split(ControlChars.CrLf.ToCharArray(), StringSplitOptions.RemoveEmptyEntries)

        Memo.AppendText("GetFileNames Channel: 0" + "-> Result: " + res.ToString)
        Memo.AppendText(vbCrLf)
        If res = tprgResult.resOk Then
            For cnt = LBound(value) To UBound(value) - 1
                comboBoxFiles.Items.Add(value(cnt))
                Memo.AppendText("GetFileNames Channel: 0, Place: " + cnt.ToString + " -> " + value(cnt) + vbCrLf)
            Next cnt
        End If
        If cnt > 0 Then
            statusBar.Items(0).Text = "Files found: " + cnt.ToString
            comboBoxFiles.SelectedIndex = 0
            btnOpenAFile.Enabled = True
            btnDeleteFile.Enabled = True
            btnGetProjParams.Enabled = True
            SelectedFile = comboBoxFiles.Text
        End If
    End Sub

    Private Sub comboBoxFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBoxFiles.SelectedIndexChanged
        SelectedFile = comboBoxFiles.Text
    End Sub

    Private Sub Memo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Memo_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Memo.Clear()
    End Sub

    Private Sub CloseFile()
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        statusBar.Items(0).Text = ""
        strProg = Space(100)
        CloseAfile(0, res, strProg)
        strRes = strProg.ToString()
        Memo.AppendText("CloseAfile Channel: 0" + "-> Result: " + res.ToString + ", Message: " + strRes)
        Memo.AppendText(vbCrLf)
        'if (iStat == prgResult.progFound)

        GroupBox2.Enabled = True
        btnGetFiles.Enabled = True
        btnTargetVoltage.Enabled = True
        btnOpenAFile.Text = "OpenAfile"
        btnEraseDevice.Enabled = False
        btnVerifyAll.Enabled = False
        btnGetFuses.Enabled = False
        btnProgDevice.Enabled = False
        comboBoxFiles.Enabled = True
        btnGetFiles.Enabled = True
        FileisOpen = False
        statusBar.Items(0).Text = " FileOpen: none"
    End Sub

    Private Sub btnOpenAFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenAFile.Click
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        statusBar.Items(0).Text = ""
        strProg = Space(100)
        If SelectedFile <> "" Then
            If Not FileisOpen Then
                OpenAfile(0, SelectedFile, res, strProg)
                strRes = strProg.ToString()                
                Memo.AppendText(("OpenAFile Channel: 0 ,'" + SelectedFile + "' -> Result: " + res.ToString + ", Message: " + strRes))
                Memo.AppendText(vbCrLf)
                If res = tprgResult.resOk Then
                    ' btnGetFiles.Enabled = true;
                    btnEraseDevice.Enabled = True
                    btnProgDevice.Enabled = True
                    btnVerifyAll.Enabled = True
                    btnGetFuses.Enabled = True
                    FileisOpen = True
                    btnOpenAFile.Text = "CloseAfile"
                    btnGetFiles.Enabled = False
                    comboBoxFiles.Enabled = False
                    statusBar.Items(0).Text = " FileOpen: " + SelectedFile
                End If
            Else
                CloseFile()
            End If

        Else
            Memo.AppendText("OpenAFile Channel: 0 , ERROR : not File seleted !!")
            Memo.AppendText(vbCrLf)

        End If
    End Sub

    Private Sub btnEraseDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEraseDevice.Click
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        statusBar.Items(0).Text = ""
        strProg = Space(100)
        EraseDevice(0, res, strProg)
        strRes = strProg.ToString()
        Memo.AppendText("EraseDevice Channel: 0" + "-> Result: " + res.ToString + ", Message: " + strRes)
        Memo.AppendText(vbCrLf)
    End Sub

    Private Sub btnTargetVoltage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTargetVoltage.Click

        Dim Volt As Integer = 0
        Dim realVolt As String = ""
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        statusBar.Items(0).Text = ""
        strProg = Space(100)
        GetTargVolt(0, Volt, res, strProg)
        strRes = strProg.ToString()
        If Volt <> 0 Then
            realVolt = Convert.ToString(Volt / 100) + " Volt "
        Else
            realVolt = "0.0 Volt "
        End If
        Memo.AppendText("GetTargVolt Channel: 0 , " + "-> Result: " + res.ToString + ", Message: " + strRes + " Volt")
        Memo.AppendText(vbCrLf)
    End Sub

    Private Sub DoVerifyDevice()

        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        statusBar.Items(0).Text = ""
        strProg = Space(100)
        If FileisOpen Then
            VerifyDevice(0, res, strProg)
            strRes = strProg.ToString()
            Memo.AppendText("VerifyDevice Channel: 0" + "-> Result: " + res.ToString + ", Message: " + strRes + vbCrLf)
            Memo.AppendText(vbCrLf)
            StartTime = GetTickCount
            If res = tprgResult.resOk Then
                cStatus = chState.cProg
                TimerProgStatus.Enabled = True
            End If
        Else
            Memo.AppendText("VerifyDevice Channel: 0 , ERROR : no File open !!" + vbCrLf)
        End If
    End Sub


    Private Sub btnVerifyAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVerifyAll.Click
        DoVerifyDevice()
    End Sub


    Private Sub btnProgDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProgDevice.Click
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim buf As String
        Dim strData As String
        Dim adr As Integer
        statusBar.Items(0).Text = ""
        buf = Space(256)
        strData = Space(32)
        If FileisOpen Then

            If (cbDownOverFlash.Checked) Then
                '  usable for patching a serial number or a MAC address
                '  while programming the selected memory type , max 32 bytes
                '  or
                '  DownOverBlockE for EEprom
                '  DownOverBlockU for UserRow
                adr = Val(edDownOverFlash.Text) ' quick and dirty  
                strData = edSerial.Text         ' "
                DownOverBlockF(0, System.Runtime.InteropServices.Marshal.StringToHGlobalAnsi(strData), adr, strData.Length(), res, buf)
                strRes = buf.ToString()
                Memo.AppendText("ProgDevice DownOverBlockF is set : 0 -> Result: " + res.ToString + ", Message: " + strRes + vbCrLf)
                If (res <> tprgResult.resOk) Then
                    Return
                End If
            End If


            ProgDevice(0, res, buf)
            strRes = buf.ToString()
            Memo.AppendText("ProgDevice Channel: 0" + "-> Result: " + res.ToString + ", Message: " + strRes + vbCrLf)
            StartTime = GetTickCount()
            Memo.AppendText(vbCrLf)
            If res = tprgResult.resOk Then
                cStatus = chState.cProg
                TimerProgStatus.Enabled = True
            End If
        Else
            Memo.AppendText("ProgDevice Channel: 0 , ERROR : no File open !!" + vbCrLf)
        End If
    End Sub

    Private Sub btnDeleteFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeleteFile.Click
        Dim res As tprgResult
        Dim strRes As String = ""
        Dim buf As String
        buf = Space(256)
        statusBar.Items(0).Text = ""

        If (SelectedFile <> "") Then
            If (Not FileisOpen) Then
                If (MsgBox("Delete file " + SelectedFile, MsgBoxStyle.YesNo, "Question") = MsgBoxResult.Yes) Then
                    DeleteAfile(0, SelectedFile, res, buf)
                    strRes = buf.ToString()
                    statusBar.Items(0).Text = " FileOpen: " + SelectedFile
                    Memo.AppendText("DeleteAfile Channel: 0 ,'" + SelectedFile + "' -> Result: " + res.ToString + ", Message: " + strRes + vbCrLf)
                    Memo.AppendText(vbCrLf)
                    If (res = tprgResult.resOk) Then
                        btnGetFiles_Click(sender, e)
                    End If
                End If
            Else
                CloseFile()
            End If
        Else
            Memo.AppendText("DeleteAfile Channel: 0 , ERROR : not File seleted !!" + vbCrLf)
        End If
    End Sub



    Private Sub btnDownloadFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDownloadFile.Click
        Dim res As tprgResult
        Dim strRes As String = ""
        Dim strFile As String = ""
        Dim buf As String        
        buf = Space(256)      
        statusBar.Items(0).Text = ""
        TimerProgStatus.Enabled = False
        Try
            If (Not FileisOpen) Then   ' !! or try GetFileState() to verify no file is open
                OpenDialog1.FileName = ""
                If (OpenDialog1.ShowDialog() = DialogResult.OK) Then
                    strFile = OpenDialog1.FileName
                    If (strFile = "") Then Return
                End If
            End If
            Memo.AppendText("DownloadAFile in progress " + (Mid(strFile, InStrRev(strFile, "\") + 1, Len(strFile))) + " ....." + vbCrLf)
            GroupBox1.Enabled = False
            Application.DoEvents()
            Cursor.Current = Cursors.WaitCursor
            Downloadfile(0, strFile, res, buf)
            strRes = buf.ToString()
            Memo.AppendText(("DownloadAFile Channel: 0 -> Result: " + res.ToString + ", Message: " + strRes) + vbCrLf)
            Memo.AppendText(vbCrLf)
            If (res = tprgResult.resOk) Then
                btnGetFiles_Click(sender, e)
            Else
                Memo.AppendText("DownloadAFile Channel: 0 , ERROR :  File is open !!" + vbCrLf)
            End If
        Finally
            GroupBox1.Enabled = True
            Cursor.Current = Cursors.Default
        End Try
    End Sub

    Private Sub btnGetProjParams_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetProjParams.Click
        Dim res As tprgResult
        Dim strRes As String = ""
        Dim str1 As String = ""
        Dim buf As String
        buf = Space(256)
        Dim strList() As String

        statusBar.Items(0).Text = ""

        If (SelectedFile <> "") Then

            GetProjParams(0, SelectedFile, res, buf)
            Memo.AppendText("GetProjParams: " + SelectedFile + vbCrLf)
            strRes = buf.ToString
            strList = strRes.Split(ControlChars.CrLf.ToCharArray(), StringSplitOptions.RemoveEmptyEntries)
            For cnt = LBound(strList) To UBound(strList) - 1
                str1 = "Parm: " + cnt.ToString + "-> " + strList(cnt)
                Memo.AppendText("   " + str1 + vbCrLf)
            Next ' file is closed by Dll now

            CloseFile()
        Else
            Memo.AppendText("GetProjParams: no File selected" + vbCrLf)
        End If
    End Sub


    Private Sub DoGetFuses()

        Dim Locks As Integer = 255
        Dim fuseLo As Integer = 255
        Dim fuseHi As Integer = 255
        Dim fuseExt As Integer = 255
        Dim fuseI As Integer = 255
        Dim fuseJ As Integer = 255
        Dim fuseK As Integer = 255        
        Dim Cal0 As Integer = 255
        Dim Cal1 As Integer = 255
        Dim Cal2 As Integer = 255
        Dim Cal3 As Integer = 255

        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim PstBuffer As String
        statusBar.Items(0).Text = ""
        PstBuffer = Space(100)


        If FileisOpen Then
            Cursor.Current = Cursors.WaitCursor
            Try
                ' "L", "F", "H", "E", "0", "1", "2", "3"
                GetFuses(0, "L", Locks, res, PstBuffer)
                If res <> tprgResult.resOk Then
                    strRes = PstBuffer.ToString()
                    Memo.AppendText("GetFuse Channel: 0" + "-> Result: " + Convert.ToString(res) + ", Message: " + strRes + "    , Atmel fuse notation  enabled = 0, disabled = 1 " + vbCrLf)
                    Memo.AppendText(vbCrLf)
                    ' Exit !!!!!!
                End If
                GetFuses(0, "F", fuseLo, res, PstBuffer)   ' Fuse 0
                ' todo Error check
                GetFuses(0, "H", fuseHi, res, PstBuffer)   ' Fuse 1
                ' todo Error check ...
                GetFuses(0, "E", fuseExt, res, PstBuffer)  ' Fuse 2
                GetFuses(0, "I", fuseI, res, PstBuffer)    ' Fuse 3
                GetFuses(0, "J", fuseJ, res, PstBuffer)    ' Fuse 4
                GetFuses(0, "K", fuseK, res, PstBuffer)    ' Fuse 5               
                GetFuses(0, "0", Cal0, res, PstBuffer)
                GetFuses(0, "1", Cal1, res, PstBuffer)
                GetFuses(0, "2", Cal2, res, PstBuffer)
                GetFuses(0, "3", Cal3, res, PstBuffer)

                Memo.AppendText("   Lockbits : 0x" + Locks.ToString("X2") + vbCrLf)
                Memo.AppendText("   Fuse0    : 0x" + fuseLo.ToString("X2") + vbCrLf)
                Memo.AppendText("   Fuse1    : 0x" + fuseHi.ToString("X2") + vbCrLf)
                Memo.AppendText("   Fuse2    : 0x" + fuseExt.ToString("X2") + vbCrLf)
                Memo.AppendText("   Fuse3    : 0x" + fuseI.ToString("X2") + vbCrLf)
                Memo.AppendText("   Fuse4    : 0x" + fuseJ.ToString("X2") + vbCrLf)
                Memo.AppendText("   Fuse5    : 0x" + fuseK.ToString("X2") + vbCrLf)               
                Memo.AppendText("   Cal0     : 0x" + Cal0.ToString("X2") + vbCrLf)
                Memo.AppendText("   Cal1     : 0x" + Cal1.ToString("X2") + vbCrLf)
                Memo.AppendText("   Cal2     : 0x" + Cal2.ToString("X2") + vbCrLf)
                Memo.AppendText("   Cal3     : 0x" + Cal3.ToString("X2") + vbCrLf)

            Finally
                Cursor.Current = Cursors.Default
            End Try
        Else
            Memo.AppendText("GetFuse Channel: 0 , ERROR : no File open !!" + vbCrLf)
            Memo.AppendText(vbCrLf)
        End If
    End Sub

  

    Private Sub btnGetFuses_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetFuses.Click
        DoGetFuses()
    End Sub

    Private Sub TimerProgStatus_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerProgStatus.Tick
        Dim res As tprgResult = tprgResult.resOk
        Dim strRes As String = ""
        Dim strProg As String
        Dim idx As Integer        
        strProg = Space(100)
        Dim allIdle As Integer = 0
        GroupBox2.Enabled = False
        For idx = 0 To ProgrammersFound - 1
            If (cStatus <> chState.cIdle) Then
                GetProgStatus(0, res, strProg)
                strRes = strProg.ToString()
                If strLast <> strRes Then
                    strLast = strRes
                    Select Case res
                        Case tprgResult.progDone
                            EndTime = GetTickCount
                            Memo.AppendText(vbCrLf + "GetProgStatus >done< :) " + (((EndTime - StartTime) / 1000)).ToString + " sec." + vbCrLf)
                            ReleaseTarget(0, res, strProg)
                            strRes = strProg.ToString()
                            ' if desired !!
                            Memo.AppendText("ReleaseTarget Channel: 0" + "-> Result: " + res.ToString + ", Message: " + strRes + vbCrLf)
                            GroupBox2.Enabled = True
                            cStatus = chState.cIdle
                            allIdle = allIdle + 1
                            statusBar.Items(0).Text = " programming finished"
                        Case tprgResult.eraChip
                            Memo.AppendText(vbCrLf + "GetProgStatus >c< erase Chip" + vbCrLf)
                        Case tprgResult.verifyUsrRow
                            Memo.AppendText(vbCrLf + "GetProgStatus >U< verify UserRow" + vbCrLf)
                        Case tprgResult.prgUsrRow
                            Memo.AppendText(vbCrLf + "GetProgStatus >U< program UserRow" + vbCrLf)
                        Case tprgResult.verifyEEp
                            Memo.AppendText(vbCrLf + "GetProgStatus >E< verify EEprom" + vbCrLf)
                        Case tprgResult.prgEEp
                            Memo.AppendText(vbCrLf + "GetProgStatus >E< program EEprom" + vbCrLf)
                        Case tprgResult.verifyFlash
                            Memo.AppendText(vbCrLf + "GetProgStatus >V< verify Flash" + vbCrLf)
                        Case tprgResult.prgFlash
                            Memo.AppendText(vbCrLf + "GetProgStatus >F< program Flash" + vbCrLf)
                        Case tprgResult.limitExc, tprgResult.PwrDownErr, tprgResult.SignatureErr, tprgResult.ProtectedErr, tprgResult.NotEmptyErr, tprgResult.VerifyErr, tprgResult.FileErr
                            GroupBox2.Enabled = True
                            cStatus = chState.cIdle
                            allIdle = allIdle + 1
                            Memo.AppendText(vbCrLf + "GetProgStatus >Error< " + vbCrLf)

                        Case tprgResult.progTimeOutErr
                            GroupBox2.Enabled = True
                            allIdle = 999
                            cStatus = chState.cIdle
                            Memo.AppendText(vbCrLf + "GetProgStatus >8< communication TimeOut" + vbCrLf)

                        Case Else
                            GroupBox2.Enabled = True
                            allIdle = 999
                            cStatus = chState.cIdle
                            Memo.AppendText(vbCrLf + "GetProgStatus >?< unknown error" + vbCrLf)

                    End Select
                Else
                    Memo.AppendText("*")
                End If

            Else
                allIdle = allIdle + 1
            End If

        Next idx
        If (allIdle >= ProgrammersFound) Then
            TimerProgStatus.Enabled = False
            GroupBox2.Enabled = True
            str = ""
        End If
    End Sub




    Private Sub Memo_DoubleClick_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Memo.DoubleClick
        Memo.Clear()
    End Sub

   
    
End Class
